function varargout = LoadMoreVideo(varargin)
% LOADMOREVIDEO will load additional video frames to enable the user to
% syncronize with data, or just for viewing.
% This function takes in the size of video frames to be loaded into memory 
% at once, and the number of the last frame in the video file.  The output
% is the number of the 1st frame that should be loaded.
%USE: loadFramesFrom=LoadMoreVideo(BlockSize,LastFrame);
% 04/28/06 - Created for use with VIDSYNC_VIDGUI

% LOADMOREVIDEO M-file for LoadMoreVideo.fig
%      LOADMOREVIDEO, by itself, creates a new LOADMOREVIDEO or raises the existing
%      singleton*.
%
%      H = LOADMOREVIDEO returns the handle to a new LOADMOREVIDEO or the handle to
%      the existing singleton*.
%
%      LOADMOREVIDEO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LOADMOREVIDEO.M with the given input arguments.
%
%      LOADMOREVIDEO('Property','Value',...) creates a new LOADMOREVIDEO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LoadMoreVideo_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to LoadMoreVideo_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
% Copyright 2002-2003 The MathWorks, Inc.
% Edit the above text to modify the response to help LoadMoreVideo
% Last Modified by GUIDE v2.5 27-Apr-2006 20:46:26
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LoadMoreVideo_OpeningFcn, ...
                   'gui_OutputFcn',  @LoadMoreVideo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before LoadMoreVideo is made visible.
function LoadMoreVideo_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LoadMoreVideo (see VARARGIN)

%Get the input data
maxvideoframes=varargin{1};
LastFrame=varargin{2};
handles.maxvideoframes=maxvideoframes;
handles.LastFrame=LastFrame;
%Update the user on how many frames will be loaded
ftext=['(' num2str(maxvideoframes) ' frames will be loaded)'];
set(handles.FrameNumText,'String',ftext);

% Choose default command line output for LoadMoreVideo
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes LoadMoreVideo wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = LoadMoreVideo_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
%Output the frame where new video loading should begin
varargout{1} = str2double(get(handles.LoadVideoFrame,'String'));  
%Close the window GUI
close


function LoadVideoFrame_Callback(hObject, eventdata, handles)
% hObject    handle to LoadVideoFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of LoadVideoFrame as text
%        str2double(get(hObject,'String')) returns contents of LoadVideoFrame as a double

%Get the necessary variables into nice variables
FrameNum=round(str2double(get(handles.LoadVideoFrame,'String')));
BlockSize=handles.maxvideoframes;
LastFrame=handles.LastFrame;

%Try to make sure that a full block of data is loaded
if FrameNum+BlockSize>LastFrame
    FrameNum=LastFrame-BlockSize;
end
%Make sure negative (invalid) frames are not requested
if FrameNum<1
    FrameNum=1;
end

%Update the display with correct frame number
set(handles.LoadVideoFrame,'String',num2str(FrameNum));
% Choose default command line output for LoadMoreVideo
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function LoadVideoFrame_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LoadVideoFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in OKButton.
function OKButton_Callback(hObject, eventdata, handles)
% hObject    handle to OKButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Return the control to the calling script command sequence (Main (or previous) window)
uiresume;
